close all;

I=imread('objects.gif');
I=double(I);
S = thresholding(I,190,210);
L = labeling(S);
C = computeCentroids(L);

%Centroid of the ellipse
center_x = 105.6;
center_y = 217;

%Label of the ellipse
label = getLabel(L,center_x,center_y);

%Pixel list of the ellipse
pixel_list = getPixelList(L,label);

%Plot the ellipse
figure; plot(pixel_list(1,:),pixel_list(2,:),'*');
title('Ellipse with main axes');
hold on;

%Covariance matrix of pixel positions
m = cov(pixel_list(1,:),pixel_list(2,:))
%Eigenvalue decomposition
[U,V] = eig(m);

%Axes calculation
axis1 = [0 0; U(:,2)']' * sqrt(V(2,2)) * 2;
axis2 = [0 0; U(:,1)']' * sqrt(V(1,1)) * 2;
axis1(1,:) = axis1(1,:) + center_x;
axis1(2,:) = axis1(2,:) + center_y;
axis2(1,:) = axis2(1,:) + center_x;
axis2(2,:) = axis2(2,:) + center_y;

%Plotting the axes
plot(axis1(1,:),axis1(2,:),'r','LineWidth',3);
plot(axis2(1,:),axis2(2,:),'g','LineWidth',3);
axis equal;
axis ij;
hold off;

